'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.loadingReferTree = loadingReferTree;
exports.loadingReferGrid = loadingReferGrid;
exports.getRefinfo = getRefinfo;
exports.getLazyTreeData = getLazyTreeData;
exports.getTreeData = getTreeData;
exports.getGridData = getGridData;
exports.doReload = doReload;
exports.clearPreDatas = clearPreDatas;
exports.getOften = getOften;
exports.addOften = addOften;
exports.deleteOften = deleteOften;
exports.saveInnerFilterObject = saveInnerFilterObject;
exports.delInnerFilterObject = delInnerFilterObject;

var _ReferConstants = require('../constants/ReferConstants');

var ajax = require('../../../../utils/ajax');
// var ajax = require('../utils/ajax');
var TreeUtils = require("../../../../utils/TreeUtils");
var _ = require('lodash');

/*按照id获取参照配置表数据*/
function getRefinfoByIdSuccess(key, data) {
    return {
        type: _ReferConstants.GET_PFREFINFO_BYCODE_SUCCESS,
        key: key,
        data: data
    };
}
function getRefinfoByIdFail(flag) {
    return {
        type: _ReferConstants.GET_PFREFINFO_BYCODE_ERROR,
        flag: flag
    };
}
/*获取树数据*/
var getTreeDataSuccess = function getTreeDataSuccess(data) {
    return function (dispatch) {
        dispatch({
            type: _ReferConstants.GET_PFTREEDATA_REF_SUCCESS,
            data: data
        });
        return Promise.resolve();
    };
};
function getTreeDataFail(flag) {
    return {
        type: _ReferConstants.GET_PFTREEDATA_REF_ERROR,
        flag: flag
    };
}
/*获取表数据*/
function getGridDataSuccess(data) {
    return {
        type: _ReferConstants.GET_PFGRIDDATA_REF_SUCCESS,
        data: data
    };
}
function getGridDataFail(flag) {
    return {
        type: _ReferConstants.GET_PFGRIDDATA_REF_ERROR,
        flag: flag
    };
}

/*获取树表数据: 表*/
function getTreeGridDataSuccess(data) {
    return {
        type: _ReferConstants.GET_PFTREEGRIDDATA_REF_SUCCESS,
        data: data
    };
}
function getTreeGridDataFail(flag) {
    return {
        type: _ReferConstants.GET_PFTREEGRIDDATA_REF_ERROR,
        flag: flag
    };
}

/*获取树表数据: 树数据+表数据*/
function getTreeAndGridDataSuccess(treeData, treeGridData) {
    return {
        type: _ReferConstants.GET_PFTREE_AND_GRID_REF_SUCCESS,
        treeData: treeData,
        treeGridData: treeGridData
    };
}

/*获取常用*/
function getOftenSuccess(data) {
    return {
        type: _ReferConstants.GET_PFREFER_OFTEN_SUCCESS,
        data: data
    };
}

function getOftenError(data) {
    return {
        type: _ReferConstants.GET_PFREFER_OFTEN_ERROR,
        data: data
    };
}

/*保存常用*/
function saveOftenSuccess(data, ifShowMsg) {
    return {
        type: _ReferConstants.SAVE_PFREFER_OFTEN_SUCCESS,
        ifShowMsg: ifShowMsg,
        data: data
    };
}
function saveOftenError(errorMsg) {
    return {
        type: _ReferConstants.SAVE_PFREFER_OFTEN_ERROR,
        errorMsg: errorMsg
    };
}

/*删除常用*/
function deleteOftenSuccess(data) {
    return {
        type: _ReferConstants.DELETE_PFREFER_OFTEN_SUCCESS,
        data: data
    };
}
function deleteOftenError(data) {
    return {
        type: _ReferConstants.DELETE_PFREFER_OFTEN_ERROR,
        errorMsg: errorMsg
    };
}
function loadingReferTree(loading) {
    return {
        type: _ReferConstants.LOADING_PFREFER_TREE,
        loadingReferTree: loading
    };
}
function loadingReferGrid(loading) {
    return {
        type: _ReferConstants.LOADING_PFREFER_GRID,
        loadingReferGrid: loading
    };
}
//修改devsc 直接传入data
// export function getRefinfo(serverUrl, key,querydata) {
//     return function (dispatch) {
//         console.log('getRefkey:', key);
//         switch (key){
//             case '00021':
//                 return dispatch(getRefinfoByIdSuccess(key,gangwei00021));
//                 break;
//             case '99977':
//                 // return dispatch(getRefinfoByIdSuccess(key,gangwei01));
//                 return dispatch(getRefinfoByIdSuccess(key,bumentree));
//                 break;
//             case 'gwzd01':
//                 return dispatch(getRefinfoByIdSuccess(key,gangwei01));
//                 break;
//             case '00061':
//                 return dispatch(getRefinfoByIdSuccess(key,bumentree));
//                 break;
//             case '00007':
//                 return dispatch(getRefinfoByIdSuccess(key,bumentree));
//                 break;
//             default:
//                 console.log('getRefDefault');
//             ajax.request({
//                 method : 'GET',
//                 url : serverUrl+GET_REFINFO_BYCODE,
//                 query : querydata,
//                 type : 'json',
//                 success : function(data) {
//                     console.log('getRefinfo',data)
//                     return dispatch(getRefinfoByIdSuccess(key,data));
//                 },
//                 error : function(data) {
//                     return dispatch(getRefinfoByIdFail(true));
//                 }
//             });
//         }
//
//     };
// }

function getRefinfo(serverUrl, key, data) {
    return function (dispatch) {
        ajax.request({
            method: 'POST',
            url: serverUrl,
            send: { referCode: key },
            type: 'json',
            success: function success(data) {
                console.log('getRefinfo', JSON.parse(data.data.referVal), data.data);
                if (data.code == '0') {
                    var referdata = {
                        msg: '',
                        success: true,
                        data: JSON.parse(data.data.referVal)
                    };
                    return dispatch(getRefinfoByIdSuccess(key, referdata));
                }
            },
            error: function error(data) {
                return dispatch(getRefinfoByIdFail(true));
            }
        });
        // return dispatch(getRefinfoByIdSuccess(key,data));
    };
}

/**
 * 异步树加载
 * @param treeData
 * @param treeNode
 */
function getLazyTreeData(options) {
    var dataurl = options.dataurl,
        dispatch = options.dispatch,
        curKey = options.curKey,
        treeData = options.treeData,
        resolve = options.resolve,
        queryData = options.queryData;

    queryData = _.assign({}, queryData, { parentId: curKey });
    console.log('getLazyTree:', options);
    ajax.postJSON(dataurl, queryData, function (result) {
        var backData = result;
        if (backData.code == '0') {
            var loop = function loop(data) {
                _.forEach(data, function (item) {
                    if (curKey == item.id) {
                        item.children = backData.data;
                    } else {
                        if (item.children) {
                            loop(item.children);
                        }
                    }
                });
            };
            loop(treeData);
            console.log('获取获取树数据:', queryData, treeData);
            dispatch(getTreeDataSuccess(treeData)).then(function () {
                resolve();
            });
        } else {
            resolve();
        }
    }, function (error) {
        resolve();
    });
}

// queryType === PFREFER_TYPE_TREEGRID情况下， dataurl、queryGrid生效
function getTreeData(dataurl, querydata, queryType, queryGrid) {
    return function (dispatch) {
        dispatch(loadingReferTree(true));
        var header = {
            method: queryGrid && queryGrid.queryMethod ? queryGrid.queryMethod : 'GET',
            url: dataurl,
            send: querydata,
            query: querydata,
            type: 'json',
            accept: 'text'
        };
        if (header.method.toLowerCase() == 'get') {
            delete header.send;
        } else if (header.method.toLowerCase() == "post") {
            delete header.query;
        }
        ajax.request(_.assign({}, header, {
            success: function success(data) {
                //如果data=""空字符串 treeData={}
                var treeData = !!data ? JSON.parse(data).data : {};
                console.log('getTree', treeData);
                if (queryType === _ReferConstants.PFREFER_TYPE_TREEGRID) {
                    // 树表参照, 查询树后 默认根据第一个根的第一个子节点查询grid数据
                    var querydata = queryGrid.querydata;
                    if (treeData && treeData[0] && queryGrid && queryGrid.dataurl) {
                        // 第二次发起请求，失败的话，dispatch(getGridDataSuccess(data))
                        var nodeKey = null;
                        if (queryGrid.nodeKey && TreeUtils.findById(treeData, queryGrid.nodeKey)) {
                            nodeKey = queryGrid.nodeKey;
                        } else {
                            if (treeData[0].children && treeData[0].children[0]) {
                                nodeKey = treeData[0].children[0].id;
                            } else {
                                nodeKey = treeData[0].id;
                            }
                        }
                        if (querydata) {
                            // var fullCondition = querydata.relyCondition;
                            // // queryGrid.relyfield 是必传的参数，如果没有，说明程序错误。所以此处不加非空判断
                            // if(fullCondition){
                            //     fullCondition += "&"+ queryGrid.relyfield + "="+nodeKey;
                            // }else{
                            //     fullCondition = queryGrid.relyfield + "="+nodeKey;
                            // }
                            // querydata.relyCondition = fullCondition;
                            querydata.paramMap = {
                                postDictLevelId: nodeKey,
                                type: null,
                                searchText: queryGrid.searchText
                            };
                        }
                        dispatch(loadingReferGrid(true));
                        var options = {
                            method: queryGrid.queryMethod || 'GET',
                            url: queryGrid.dataurl,
                            send: querydata,
                            query: querydata,
                            type: 'json',
                            success: function success(gridData) {
                                console.log('获取表的数据11112222', typeof gridData === 'undefined' ? 'undefined' : _typeof(gridData), gridData, gridData.data);
                                dispatch(loadingReferGrid(false));
                                return dispatch(getTreeAndGridDataSuccess(treeData, gridData));
                            },
                            error: function error(gridData) {
                                dispatch(loadingReferGrid(false));
                                // return dispatch(getTreeGridDataFail(true));
                                return dispatch(getTreeDataSuccess(treeData));
                            }
                        };
                        if (options.method.toLowerCase() == 'get') {
                            delete options.send;
                        } else if (options.method.toLowerCase() == "post") {
                            delete options.query;
                        }
                        ajax.request(options);
                    }
                }
                dispatch(loadingReferTree(false));
                return dispatch(getTreeDataSuccess(treeData));
            },
            error: function error(data) {
                dispatch(loadingReferTree(false));
                return dispatch(getTreeDataFail(true));
            }
        }));
    };
}

function getGridData(dataurl, querydata, queryType, options) {
    var _ref = options || {},
        queryMethod = _ref.queryMethod,
        searchObject = _ref.searchObject;

    return function (dispatch) {
        dispatch(loadingReferGrid(true));
        // 将内嵌行筛选的条件传递后台
        if (_.isObject(searchObject) && !_.isEmpty(searchObject)) {
            // 删除searchObject里面value为空的项
            for (var key in searchObject) {
                if (!searchObject['' + key]) {
                    delete searchObject['' + key];
                }
            }
            if (!_.isEmpty(searchObject)) {
                querydata.searchObject = JSON.stringify(searchObject);
            }
        }
        var options = {
            method: queryMethod || 'GET',
            url: dataurl,
            send: querydata,
            query: querydata,
            type: 'json',
            success: function success(data) {
                dispatch(loadingReferGrid(false));
                if (queryType === _ReferConstants.PFREFER_TYPE_TREEGRID) {
                    return dispatch(getTreeGridDataSuccess(data));
                } else {
                    return dispatch(getGridDataSuccess(data));
                }
            },
            error: function error(data) {
                dispatch(loadingReferGrid(false));
                if (queryType === _ReferConstants.PFREFER_TYPE_TREEGRID) {
                    return dispatch(getTreeGridDataFail(true));
                } else {
                    return dispatch(getGridDataFail(true));
                }
            }
        };
        if (options.method.toLowerCase() == 'get') {
            delete options.send;
        } else if (options.method.toLowerCase() == "post") {
            delete options.query;
        }
        ajax.request(options);
    };
}

function doReload() {
    return function (dispatch) {
        return dispatch({
            type: _ReferConstants.DO_PFRELOAD_REF
        });
    };
}

function clearPreDatas() {
    return function (dispatch) {
        return dispatch({
            type: _ReferConstants.DO_PFCLEAR_PREDATAS
        });
    };
}

// 查询常用
function getOften(serverUrl, params) {
    return function (dispatch) {
        ajax.request({
            method: 'GET',
            url: ajax.fillUrlParams(serverUrl + _ReferConstants.GET_PFREFER_OFTEN, params),
            type: 'json',
            success: function success(data) {
                if (data) {
                    return dispatch(getOftenSuccess(data.backData));
                } else {
                    return dispatch(getOftenError(data.backMsg));
                }
            },
            error: function error(data) {
                return dispatch(getOftenError(_ReferConstants.PFREFER_ERROR_MSG));
            }
        });
    };
}

// 添加常用
function addOften(serverUrl, sendDatas, ifShowMsg) {
    return function (dispatch) {
        ajax.request({
            method: 'post',
            url: serverUrl + _ReferConstants.SAVE_PFREFER_OFTEN,
            send: JSON.stringify(sendDatas),
            type: 'json',
            success: function success(data) {
                if (data && data.success === true) {
                    return dispatch(saveOftenSuccess(data.backData, ifShowMsg));
                } else {
                    return dispatch(saveOftenError(data.backMsg));
                }
            },
            error: function error(data) {
                return dispatch(saveOftenError(_ReferConstants.PFREFER_ERROR_MSG));
            }
        });
    };
}

// 删除常用
function deleteOften(serverUrl, params) {
    return function (dispatch) {
        ajax.request({
            method: 'get',
            url: ajax.fillUrlParams(serverUrl + _ReferConstants.DELETE_PFREFER_OFTEN, params),
            type: 'json',
            success: function success(data) {
                if (data && data.success === true) {
                    return dispatch(deleteOftenSuccess(data.backData));
                } else {
                    return dispatch(deleteOftenError(data.backMsg));
                }
            },
            error: function error(data) {
                return dispatch(deleteOftenError(_ReferConstants.PFREFER_ERROR_MSG));
            }
        });
    };
}
// 保存参照内嵌行筛选条件
function saveInnerFilterObject(data) {
    return {
        type: _ReferConstants.SAVE_PFINNER_FILTER_VALUE,
        data: data
    };
}
// 清除参照内嵌行筛选条件
function delInnerFilterObject(refCode) {
    return {
        type: _ReferConstants.DEL_PFINNER_FILTER_VALUE,
        key: refCode
    };
}