'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ItemContent = function (_React$PureComponent) {
    _inherits(ItemContent, _React$PureComponent);

    function ItemContent() {
        _classCallCheck(this, ItemContent);

        return _possibleConstructorReturn(this, (ItemContent.__proto__ || Object.getPrototypeOf(ItemContent)).apply(this, arguments));
    }

    _createClass(ItemContent, [{
        key: 'getClassName',
        value: function getClassName() {
            var rootPrefixCls = this.props.rootPrefixCls;

            return (0, _classnames2.default)(rootPrefixCls + '-content');
        }
    }, {
        key: 'renderDataItem',
        value: function renderDataItem(_ref) {
            var dataItem = _ref.dataItem,
                LabelAndDataIndex = _ref.LabelAndDataIndex;
            var _props = this.props,
                customRenderDataSet = _props.customRenderDataSet,
                dataItemConv = _props.dataItemConv;

            if (dataItem !== null && customRenderDataSet[LabelAndDataIndex['dataIndex']]) {
                return customRenderDataSet[LabelAndDataIndex['dataIndex']].render({ dataItem: dataItem, key: LabelAndDataIndex['dataIndex'] });
            } else {
                var item = dataItem === null ? LabelAndDataIndex['dataIndex'] : dataItemConv(dataItem[LabelAndDataIndex['dataIndex']]);
                return [_react2.default.createElement(
                    'span',
                    { className: (0, _classnames2.default)('label') },
                    LabelAndDataIndex['label']
                ), _react2.default.createElement(
                    'span',
                    { className: (0, _classnames2.default)('item'), title: item },
                    item
                )];
            }
        }
    }, {
        key: 'renderContent',
        value: function renderContent() {
            var _this2 = this;

            var _props2 = this.props,
                dataItem = _props2.dataItem,
                itemContentCol = _props2.itemContentCol,
                itemContentDataSet = _props2.itemContentDataSet,
                itemContentRowGutter = _props2.itemContentRowGutter;

            var content = [];
            var rowContext = [];
            var colSpan = 24 / itemContentCol;
            itemContentDataSet.map(function (item, index) {
                rowContext.push(_react2.default.createElement(
                    _yylibUi.YYCol,
                    { span: colSpan },
                    _this2.renderDataItem({ dataItem: dataItem, LabelAndDataIndex: item.props || item })
                ));
                if ((index + 1) % itemContentCol === 0) {
                    content.push(_react2.default.createElement(
                        _yylibUi.YYRow,
                        { gutter: itemContentRowGutter },
                        [].concat(rowContext)
                    ));
                    rowContext.length = 0;
                }
            });
            while (rowContext.length < itemContentCol) {
                rowContext.push(_react2.default.createElement(_yylibUi.YYCol, { span: colSpan }));
            }
            if (rowContext.length > 0) {
                content.push(_react2.default.createElement(
                    _yylibUi.YYRow,
                    { gutter: itemContentRowGutter },
                    [].concat(rowContext)
                ));
                rowContext.length = 0;
            }
            return content;
        }
    }, {
        key: 'render',
        value: function render() {
            var renderItemContent = this.props.renderItemContent;

            return _react2.default.createElement(
                'div',
                { className: this.getClassName() },
                renderItemContent ? renderItemContent() : this.renderContent()
            );
        }
    }]);

    return ItemContent;
}(_react2.default.PureComponent);

ItemContent.defaultProps = {
    rootPrefixCls: 'ijz-listitem',
    dataItem: null,
    renderItemContent: null,
    itemContentCol: 2,
    itemContentDataSet: [],
    itemContentRowGutter: 16,
    customRenderDataSet: null,
    dataItemConv: null
};
exports.default = ItemContent;