'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _yylibUi = require('yylib-ui');

var _YYEnumSelect = require('../../../enum/YYEnumSelect');

var _YYEnumSelect2 = _interopRequireDefault(_YYEnumSelect);

var _Constant = require('../../../search/Constant');

var _Constant2 = _interopRequireDefault(_Constant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItemType = require('../../../widgets/FormItemType');
var url = require('../../../search/Resturl');

var searchTable = function (_React$Component) {
    _inherits(searchTable, _React$Component);

    function searchTable() {
        var _ref;

        var _temp, _this2, _ret;

        _classCallCheck(this, searchTable);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref = searchTable.__proto__ || Object.getPrototypeOf(searchTable)).call.apply(_ref, [this].concat(args))), _this2), _this2.state = {
            cellErrors: {}
        }, _temp), _possibleConstructorReturn(_this2, _ret);
    }

    _createClass(searchTable, [{
        key: 'getClassName',
        value: function getClassName() {
            var rootPrefixCls = this.props.rootPrefixCls;

            return (0, _classnames2.default)(rootPrefixCls + '-table');
        }
    }, {
        key: 'generateColumns',
        value: function generateColumns() {
            var _this = this;
            var columns = [{
                key: "title",
                dataIndex: "title",
                title: "条件名称"
            }, {
                key: "oper",
                dataIndex: "oper",
                title: "逻辑",
                uisubtype: 'select',
                render: function render(value, rowData, index) {
                    return _this.renderCompareCol(value, rowData, index, 'logic');
                }
            }, {
                key: "value",
                dataIndex: "value",
                title: "条件值",
                render: function render(value, rowData, index) {
                    return _this.renderDataCol(value, rowData, index, 'value');
                }
            }, {
                key: "operate",
                dataIndex: "operate",
                title: "行操作",
                width: 50,
                render: function render(value, rowData, index) {
                    return rowData.required ? _react2.default.createElement(
                        'span',
                        { style: { color: 'red' } },
                        '*'
                    ) : _react2.default.createElement(_yylibUi.YYIcon, { type: 'cross-circle', onClick: _this.onRowDel.bind(_this, value, rowData, index) });
                }
            }];
            return columns;
        }
    }, {
        key: 'renderCompareCol',
        value: function renderCompareCol(value, rowData, index, dataIndex) {
            var options = [];
            _lodash2.default.forEach(rowData.oper || [], function (subItem) {
                options.push(_react2.default.createElement(
                    _yylibUi.YYOption,
                    { key: subItem, value: subItem },
                    _Constant2.default.oper[subItem]
                ));
            });
            return _react2.default.createElement(
                _yylibUi.YYSelect,
                {
                    defaultValue: (rowData.oper || [])[0],
                    value: _Constant2.default.oper[value],
                    key: rowData.field,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex),
                    disableClear: true
                },
                options
            );
        }
    }, {
        key: 'renderDataCol',
        value: function renderDataCol(value, rowData, index, dataIndex) {
            var cont = _react2.default.createElement(_yylibUi.YYInput, { value: '', onChange: this.onCellChange.bind(this, rowData, dataIndex) });
            var inputprops = rowData.inputprops || {};
            var presetFunc = rowData.presetFunc || {};
            var serverUrl = inputprops && inputprops.serverUrl ? inputprops.serverUrl : url.REFER_SEVER_URL;
            // 有预置函数时删除置空提示
            if (presetFunc && inputprops && inputprops.placeholder) {
                delete inputprops.placeholder;
            }
            switch (rowData.inputtype) {
                case FormItemType.input:
                    // 文本框
                    cont = _react2.default.createElement(_yylibUi.YYInput, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.date:
                    // 日期
                    if (rowData.compare === 'bt') {
                        cont = _react2.default.createElement(_yylibUi.YYRangePicker, _extends({}, inputprops, {
                            value: value,
                            onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    } else {
                        cont = _react2.default.createElement(_yylibUi.YYDatePicker, _extends({}, inputprops, {
                            value: value,
                            onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    }
                    break;
                case FormItemType.select:
                    // 下拉选择
                    cont = _react2.default.createElement(_yylibUi.YYSelect, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.inputrefer:
                    //  参照
                    cont = _react2.default.createElement(_yylibUi.YYReferInput, _extends({}, inputprops, {
                        serverUrl: serverUrl,
                        condition: inputprops.condition,
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.switch:
                    // 开关
                    cont = _react2.default.createElement(_yylibUi.YYSwitch, _extends({}, inputprops, {
                        checked: value === null ? inputprops.defaultChecked : value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.enumselect:
                    // 档案枚举
                    if (!value && inputprops.multiple === true) {
                        value = [];
                    }
                    cont = _react2.default.createElement(_YYEnumSelect2.default, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.number:
                    // 数值框
                    cont = _react2.default.createElement(_yylibUi.YYInputNumber, _extends({}, inputprops, {
                        value: value,
                        type: 'number',
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.currency:
                    // 金额框
                    cont = _react2.default.createElement(_yylibUi.YYInputNumber, _extends({}, inputprops, {
                        value: value,
                        type: 'currency',
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
                case FormItemType.autoselect:
                    // 自动匹配
                    cont = _react2.default.createElement(_yylibUi.YYAutoSelect, _extends({}, inputprops, {
                        serverUrl: serverUrl,
                        condition: inputprops.condition,
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                    break;
            }
            return _react2.default.createElement(
                'div',
                { className: (0, _classnames2.default)({ "yyui-table-state-control": this.state.cellErrors[rowData.id] }) },
                cont
            );
        }
    }, {
        key: 'onCellChange',
        value: function onCellChange(rowData, dataIndex, value) {
            var dataSource = this.props.dataSource;

            var _value = undefined;
            if (value != null && value != undefined) {
                _value = value.target ? value.target.value : value;
            }
            dataSource[_lodash2.default.findIndex(dataSource, { id: rowData.id })][dataIndex] = _value;
            this.setState({ _date: Date.now(), cellErrors: {} });
        }
    }, {
        key: 'onRowDel',
        value: function onRowDel(value, rowData, index) {
            var dataSource = this.props.dataSource;

            dataSource.splice(_lodash2.default.findIndex(dataSource, { id: rowData.id }), 1);
            this.setState({ _date: Date.now() });
        }
    }, {
        key: 'validate',
        value: function validate() {
            var dataSource = this.props.dataSource;
            var cellErrors = this.state.cellErrors;

            _lodash2.default.forEach(dataSource, function (item) {
                if (item.required === true) {
                    if (item.value === null || item.value === undefined) {
                        cellErrors[item.id] = {};
                    }
                }
            });
            this.setState({ _date: Date.now() });
            if (_lodash2.default.isEmpty(cellErrors)) {
                return true;
            } else {
                return false;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var dataSource = this.props.dataSource;

            return _react2.default.createElement(_yylibUi.YYTable, { rowKey: 'id', checkable: false, pagination: false, showHeader: false, scroll: { y: 200 },
                columns: this.generateColumns(), dataSource: dataSource });
        }
    }]);

    return searchTable;
}(_react2.default.Component);

searchTable.defaultProps = {
    rootPrefixCls: 'ijz-search',
    dataSource: []

};
exports.default = searchTable;