'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CryptoJS = require('./crypto-js');
var Pako = require('./pako');

var Nc1909 = function () {
    function Nc1909() {
        _classCallCheck(this, Nc1909);

        this.cowboy = undefined;
        this.cookiets = undefined;
        this.gzip = 0;
        this.rockin = false;
        this.cfg = {
            iv: CryptoJS.enc.Base64.parse("ZGIyMTM5NTYxYzlmZTA2OA=="),
            mode: CryptoJS.mode.CBC,
            padding: CryptoJS.pad.Pkcs7
        };
        if ((typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object') {
            this.cowboy = localStorage.getItem('cowboy');
            this.gzip = localStorage.getItem('gzip');
            this.rockin = localStorage.getItem('rockin');
        }
    }

    _createClass(Nc1909, [{
        key: 'base64encode',
        value: function base64encode(str) {
            var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
            var out = void 0,
                i = void 0,
                len = void 0;
            var c1 = void 0,
                c2 = void 0,
                c3 = void 0;

            len = str.length;
            i = 0;
            out = "";
            while (i < len) {
                c1 = str.charCodeAt(i++) & 0xff;
                if (i == len) {
                    out += base64EncodeChars.charAt(c1 >> 2);
                    out += base64EncodeChars.charAt((c1 & 0x3) << 4);
                    out += "==";
                    break;
                }
                c2 = str.charCodeAt(i++);
                if (i == len) {
                    out += base64EncodeChars.charAt(c1 >> 2);
                    out += base64EncodeChars.charAt((c1 & 0x3) << 4 | (c2 & 0xF0) >> 4);
                    out += base64EncodeChars.charAt((c2 & 0xF) << 2);
                    out += "=";
                    break;
                }
                c3 = str.charCodeAt(i++);
                out += base64EncodeChars.charAt(c1 >> 2);
                out += base64EncodeChars.charAt((c1 & 0x3) << 4 | (c2 & 0xF0) >> 4);
                out += base64EncodeChars.charAt((c2 & 0xF) << 2 | (c3 & 0xC0) >> 6);
                out += base64EncodeChars.charAt(c3 & 0x3F);
            }
            return out;
        }
    }, {
        key: 'base64decode',
        value: function base64decode(str) {
            var base64DecodeChars = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1];
            var c1 = void 0,
                c2 = void 0,
                c3 = void 0,
                c4 = void 0;
            var i = void 0,
                len = void 0,
                out = void 0;

            len = str.length;
            i = 0;
            out = "";
            while (i < len) {
                /* c1 */
                do {
                    c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
                } while (i < len && c1 == -1);
                if (c1 == -1) break;

                /* c2 */
                do {
                    c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
                } while (i < len && c2 == -1);
                if (c2 == -1) break;

                out += String.fromCharCode(c1 << 2 | (c2 & 0x30) >> 4);

                /* c3 */
                do {
                    c3 = str.charCodeAt(i++) & 0xff;
                    if (c3 == 61) return out;
                    c3 = base64DecodeChars[c3];
                } while (i < len && c3 == -1);
                if (c3 == -1) break;

                out += String.fromCharCode((c2 & 0XF) << 4 | (c3 & 0x3C) >> 2);

                /* c4 */
                do {
                    c4 = str.charCodeAt(i++) & 0xff;
                    if (c4 == 61) return out;
                    c4 = base64DecodeChars[c4];
                } while (i < len && c4 == -1);
                if (c4 == -1) break;
                out += String.fromCharCode((c3 & 0x03) << 6 | c4);
            }
            return out;
        }
    }, {
        key: 'encrypt',
        value: function encrypt(message, key) {
            var keyDigest = CryptoJS.enc.parse(key || '12345678912345678912345678912345');
            var encrypted = CryptoJS["AES"].encrypt(message, keyDigest, this.cfg);
            var ciphertext = CryptoJS.enc.Base64.stringify(CryptoJS.enc.Utf8.parse(encrypted.ciphertext.toString()));
            return ciphertext;
        }
    }, {
        key: 'decrypt',
        value: function decrypt(message, key) {
            var keyDigest = CryptoJS.enc.Base64.parse(key || '12345678912345678912345678912345');
            var plaintext = CryptoJS.enc.Base64.stringify(CryptoJS.enc.Hex.parse(CryptoJS.enc.Base64.parse(message).toString(CryptoJS.enc.Utf8)));
            var decrypted = CryptoJS["AES"].decrypt(plaintext, keyDigest, this.cfg);
            return decrypted.toString(CryptoJS.enc.Utf8);
        }
    }, {
        key: 'generateAeskey',
        value: function generateAeskey() {
            var aeskey = this.decrypt(this.cowboy, '4fa8959db7b4423a99f056e299914128');
            aeskey = this.cookiets + aeskey.substring(0, aeskey.length - this.cookiets.length);
            return aeskey;
        }
    }, {
        key: 'zip',
        value: function zip(str) {
            try {
                if (str == undefined) {
                    return null;
                }
                var gstr2 = pako.gzip(str);
                gstr2 = this.base64encode(gstr2);
                return gstr2;
            } catch (error) {
                console.error(error);
            }
        }
    }, {
        key: 'unzip',
        value: function unzip(str) {
            try {
                if (str == undefined) {
                    return null;
                }
                var gstr = this.base64decode(str);
                var strData = pako.inflate(gstr, { to: "string" });
                strData = JSON.parse(strData);
                return JSON.stringify(strData, null, 4);
            } catch (error) {
                console.error(error);
            }
        }
    }]);

    return Nc1909;
}();

module.exports = Nc1909;