'use strict';

/**
 * 子面包屑组件
 */
var _ = require('lodash');
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('react-router'),
    Link = _require.Link;

var _require2 = require('antd'),
    Breadcrumb = _require2.Breadcrumb;

require('./style/index.less');
//定义META
var uiMeta = {
    name: 'breadcrumbitem',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('visible', true, PropTypes.bool, false, "子面包屑是否显示"), field('href', '', PropTypes.string, false, '子面包屑的链接'), field('type', 'link', PropTypes.string, false, '子面包屑的链接的类型(路由[link] or 超链接[href])'), field('icon', '', PropTypes.node, false, '子面包屑的图标'), field('style', undefined, PropTypes.any, false, '组件的style样式'), field('onClick', undefined, PropTypes.func, false, '点击事件')]
};
var YYBreadcrumbItem = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var breadcrumbItem = null;
        if (this.props.visible || this.props.visible == undefined) {
            if (this.props.href && this.props.href.length > 0) {
                if (this.props.type && this.props.type === 'href') {
                    breadcrumbItem = React.createElement(
                        Breadcrumb.Item,
                        { style: this.props.style, separator: this.props.separator, onClick: this.props.onClick },
                        React.createElement(
                            'a',
                            { href: this.props.href },
                            this.props.icon,
                            this.props.children
                        )
                    );
                } else {
                    breadcrumbItem = React.createElement(
                        Breadcrumb.Item,
                        { style: this.props.style, separator: this.props.separator, onClick: this.props.onClick },
                        React.createElement(
                            Link,
                            { to: { pathname: this.props.href } },
                            this.props.icon,
                            ' ',
                            this.props.children
                        )
                    );
                }
            } else {
                breadcrumbItem = React.createElement(
                    Breadcrumb.Item,
                    { style: this.props.style, separator: this.props.separator, onClick: this.props.onClick },
                    this.props.icon,
                    ' ',
                    this.props.children
                );
            }
        }
        return breadcrumbItem;
    }
});

module.exports = YYBreadcrumbItem;