'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * 定义栅格行
 */
var React = require('react');

var _require = require('antd'),
    Row = _require.Row;

var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
//定义META
var uiMeta = {
    name: 'row',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('gutter', 0, PropTypes.number, false, '栅格间隔'), field('type', 0, PropTypes.string, false, '布局模式，可选 flex，现代浏览器下有效'), field('align', 'top', PropTypes.oneOf(['top', 'middle', 'bottom']), false, 'flex 布局下的垂直对齐方式：top middle bottom'), field('justify', 'start', PropTypes.oneOf(['start', 'end', 'center', 'space-around', 'space-between']), false, 'flex 布局下的水平排列方式：start end center space-around space-between')]
};
var YYRow = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        return React.createElement(
            Row,
            _extends({}, this.props, { className: this.className() }),
            this.props.children
        );
    }
});

module.exports = YYRow;