'use strict';

var SplitPane = require('./SplitPane');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var React = require('react');

var uiMeta = {
  name: 'splitpane',
  fields: [field('minSize', null, PropTypes.number, true, '最小尺寸'), field('maxSize', null, PropTypes.number, true, '最大尺寸'), field('step', null, PropTypes.number, false, '步长'), field('split', 'vertical', PropTypes.oneOf(['vertical', 'horizontal']), false, '分割方向，vertical-垂直线进行分割，horizontal-水平线进行分割'), field('defaultSize', null, PropTypes.number, false, '默认尺寸')]
};

var YYSplitPane = YYClass.create({
  uiMeta: uiMeta,
  render: function render() {
    return React.createElement(
      'div',
      { className: this.className() },
      React.createElement(
        SplitPane,
        this.props,
        this.props.children
      )
    );
  }
});

module.exports = YYSplitPane;